using FluentValidation;
using CMSMicroservice.Protobuf.Protos.ProductTag;
namespace CMSMicroservice.Protobuf.Validator.ProductTag;

public class GetProductTagRequestValidator : AbstractValidator<GetProductTagRequest>
{
    public GetProductTagRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetProductTagRequest>.CreateWithOptions((GetProductTagRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
